//+------------------------------------------------------------------+
//|                                               KeltnerChannel.mq4 |
//|                                                  Coded by Gilani |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 White
#property indicator_color3 White


double upper[], middle[], lower[];

extern int     TimeFrame = 0;
extern int     MA_PERIOD = 20;
extern int     MA_MODE = 0;
extern int     PRICE_MODE = 5;
extern int     ATR_PERIOD = 10;
extern double  K = 2.0;
extern bool    ATR_MODE = false;

int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexShift(0,0);
   SetIndexDrawBegin(0,0);
   SetIndexBuffer(0,upper);

   SetIndexStyle(1,DRAW_LINE,STYLE_DOT);
   SetIndexShift(1,0);
   SetIndexDrawBegin(1,0);
   SetIndexBuffer(1,middle);

   SetIndexStyle(2,DRAW_LINE);
   SetIndexShift(2,0);
   SetIndexDrawBegin(2,0);
   SetIndexBuffer(2,lower);
    

//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
  int counted_bars=IndicatorCounted();
  if(counted_bars<0) return(-1);
  if(counted_bars>0) counted_bars--;

  double avg;
   
  int limit = Bars-counted_bars;
  limit += TimeFrame/Period();

  for (int i=limit; i >= 0; i--)
  {
    int shift = iBarShift(NULL, TimeFrame, Time[i], true);
    if (shift == -1) continue;
      
    middle[i] = iMA(NULL, TimeFrame, MA_PERIOD, 0, MA_MODE, PRICE_MODE, shift);

    if (ATR_MODE)
      avg = iATR(NULL,TimeFrame,ATR_PERIOD, shift);
    else 
      avg = findAvg(ATR_PERIOD, shift);

    upper[i] = middle[i] + K*avg;
    lower[i] = middle[i] - K*avg;
  }
  
  return(0);
}

//+------------------------------------------------------------------+

double findAvg(int period, int shift)
{
  double sum=0;
  for (int x=shift;x<(shift+period);x++) 
  {
     sum += (iHigh(NULL,TimeFrame,x) - iLow(NULL, TimeFrame, x));
  }
  
  sum = sum/period;
  return (sum);
}